# Contributing to MathLive

There are many ways you can get involved with MathLive. Contributing to an open source project is fun and rewarding.

## Funding

If you're using MathLive consider donating to project development via [Patreon](https://patreon.com/arnog) (recurring donation) or [PayPal](https://www.paypal.me/arnogourdol) (one time donation).

If you are using MathLive in your project, encourage the business partners in your organization to provide financial support of open source projects.

Funds go to general development, support, and infrastructure costs.

We welcome both individual and corporate sponsors. In addition to Patreon and PayPal, we can also accept short-term development contracts for specific features or maintenance of the project.

## Contributing Issues

If you're running into some problems using MathLive or something doesn't
behave the way you think it should, please file an issue in GitHub.

Before filing something, [have a look](https://github.com/arnog/mathlive/issues)
at the existing issues. It's better to avoid filing duplicates. You can
add a comment to an existing issue if you'd like.

To speed up the resolution of an issue, including a pointer to an executable test case that demonstrates the issue, if applicable.

### Can I help fix a bug?

Sure! Have a look at the issue report, and make sure no one is already
working on it. If the issue is assigned to someone, they're on it!
Otherwise, add a comment in the issue indicating you'd like to work on
resolving the issue and go for it! See the [Contributor Guide](CONTRIBUTOR_GUIDE.md) for coding guidelines.

## Contributing Test Cases

The `test/` folder contains test cases that are used to make sure that
bugs are not introduced as new features are added (regression).

Adding or updating test cases can be very helpful
to improve MathLive's quality. Submit an issue indicating what you'd like
to work on, and a pull request when you have it ready. Test cases should
follow the TAP (Test Anything Protocol) format.

## Contributing Ideas and Feature Requests

Use the [issue tracker](https://github.com/arnog/mathlive/issues) to submit
requests for new features. First, have a look at what might already be there,
and if you don't see anything that matches, write up a new issue.

If you do see something similar to your idea, comment on it or add a 👍.

## Contributing Code

Whether you have a fix for an issue, some improved test cases, or a brand
new feature, we welcome contributions in the form of pull requests.
Once submitted, your pull request will be reviewed and you will receive
some feedback to make sure that your pull request fits in with

-   the roadmap for MathLive
-   the architecture of the project
-   the coding guidelines of the project

Once your pull request has been accepted, it will be merged
into the master branch.

Congratulations, you've become a Mathlive contributor! Thanks for your help!
